Index: palm/trunk/SCRIPTS/palmtest
===================================================================
--- palm/trunk/SCRIPTS/palmtest	(revision 3353)
+++ palm/trunk/SCRIPTS/palmtest	(revision 3354)
@@ -66,11 +66,20 @@
 
 try:
-    from termcolor import colored
+    from termcolor import colored as tcolored
 except ImportError:
-    def colored(string, color):
+    def tcolored(string, color):
         return string
 
-
-version = '1.0.0'
+disable_colored_output = False
+
+
+def colored(string, color):
+    if not disable_colored_output:
+        return tcolored(string, color)
+    else:
+        return string
+
+
+version = '1.0.1'
 
 scripts_dir = os.path.dirname(os.path.realpath(__file__))
@@ -88,6 +97,6 @@
 hline = '#' * min(terminal_columns, 300) + '\n'
 table_width_intro = 12
-table_width_builds = len(max([s for s in next(os.walk(trunk_tests_builds_dir))[1]], key=len)) + len('_debug')
-table_width_cases = len(max([s for s in next(os.walk(trunk_tests_cases_dir))[1]], key=len))
+table_width_builds = len(max([s for s in next(os.walk(trunk_tests_builds_dir))[1] if not s[0] == '.'], key=len)) + len('_debug')
+table_width_cases = len(max([s for s in next(os.walk(trunk_tests_cases_dir))[1] if not s[0] == '.'], key=len))
 table_width_cores = 7
 table_width_total = table_width_intro + table_width_builds + table_width_cases + table_width_cores + 3
@@ -954,4 +963,5 @@
         self.fail_on_debug = args.fail_on_debug
         self.dry_run = args.dry_run
+        self.no_color = args.no_color
         self.test_id = args.test_id
         self.test_case_names = args.cases
@@ -962,4 +972,6 @@
 
     def prepare(self):
+        global disable_colored_output
+        disable_colored_output = self.no_color
         self.test_dir = os.path.join(tests_dir, self.test_id)
         try:
@@ -1001,5 +1013,5 @@
 
             if 'all' in self.requested_build_names:
-                self.requested_build_names = [name for name in next(os.walk(trunk_tests_builds_dir))[1]]
+                self.requested_build_names = [name for name in next(os.walk(trunk_tests_builds_dir))[1] if not name[0] == '.']
             found_build_names = []
             for build_name in self.requested_build_names:
@@ -1017,5 +1029,5 @@
 
             if 'all' in self.test_case_names:
-                self.test_case_names = sorted([name for name in next(os.walk(trunk_tests_cases_dir))[1]])
+                self.test_case_names = sorted([name for name in next(os.walk(trunk_tests_cases_dir))[1] if not name[0] == '.'])
 
             additional_initial_runs_2 = [self.test_case_names]
@@ -1227,5 +1239,5 @@
                         if j and (jd or jd is None):
                             n_failed += 1
-            logger.to_all(r.format('Tests:', n_all, n_ok, n_debugged, n_failed))
+            logger.to_all(r.format('Tests:', n_all, n_ok, n_debugged, n_failed) + '\n')
             total_failed += n_failed
             total_debugged += n_debugged
@@ -1251,5 +1263,5 @@
 
     def get_items(self):
-        case_names = [name for name in next(os.walk(trunk_tests_cases_dir))[1]]
+        case_names = [name for name in next(os.walk(trunk_tests_cases_dir))[1] if not name[0] == '.']
         return case_names + ['all']
 
@@ -1258,5 +1270,5 @@
 
     def get_items(self):
-        build_names = [name for name in next(os.walk(trunk_tests_builds_dir))[1]]
+        build_names = [name for name in next(os.walk(trunk_tests_builds_dir))[1] if not name[0] == '.']
         return build_names + ['all']
 
@@ -1310,4 +1322,11 @@
             dest='dry_run',
             help='Prepare and process all requested tests without actually building or executing PALM.',
+            required=False,
+        )
+        self.add_argument(
+            '--no-color',
+            action='store_true',
+            dest='no_color',
+            help='Disable colored terminal output.',
             required=False,
         )
Index: palm/trunk/TESTS/cases/example_cbl/case_config.yml
===================================================================
--- palm/trunk/TESTS/cases/example_cbl/case_config.yml	(revision 3353)
+++ palm/trunk/TESTS/cases/example_cbl/case_config.yml	(revision 3354)
@@ -20,4 +20,4 @@
 significant_digits_for_netcdf_checks:
   timeseries: 3
-  profiles: 6
+  profiles: 5
   other: 8
Index: palm/trunk/TESTS/cases/example_cbl_restart/case_config.yml
===================================================================
--- palm/trunk/TESTS/cases/example_cbl_restart/case_config.yml	(revision 3353)
+++ palm/trunk/TESTS/cases/example_cbl_restart/case_config.yml	(revision 3354)
@@ -22,4 +22,4 @@
 significant_digits_for_netcdf_checks:
   timeseries: 3
-  profiles: 6
+  profiles: 5
   other: 8
Index: palm/trunk/TESTS/cases/example_cbl_restart2/case_config.yml
===================================================================
--- palm/trunk/TESTS/cases/example_cbl_restart2/case_config.yml	(revision 3353)
+++ palm/trunk/TESTS/cases/example_cbl_restart2/case_config.yml	(revision 3354)
@@ -22,4 +22,4 @@
 significant_digits_for_netcdf_checks:
   timeseries: 3
-  profiles: 6
+  profiles: 5
   other: 8
Index: palm/trunk/TESTS/cases/example_cbl_short/case_config.yml
===================================================================
--- palm/trunk/TESTS/cases/example_cbl_short/case_config.yml	(revision 3353)
+++ palm/trunk/TESTS/cases/example_cbl_short/case_config.yml	(revision 3354)
@@ -20,4 +20,4 @@
 significant_digits_for_netcdf_checks:
   timeseries: 3
-  profiles: 6
+  profiles: 5
   other: 8
Index: palm/trunk/TESTS/cases/example_cbl_user_code/case_config.yml
===================================================================
--- palm/trunk/TESTS/cases/example_cbl_user_code/case_config.yml	(revision 3353)
+++ palm/trunk/TESTS/cases/example_cbl_user_code/case_config.yml	(revision 3354)
@@ -20,4 +20,4 @@
 significant_digits_for_netcdf_checks:
   timeseries: 3
-  profiles: 6
+  profiles: 5
   other: 8