Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3351)
+++ palm/trunk/SOURCE/Makefile	(revision 3355)
@@ -488,5 +488,4 @@
 	buoyancy.f90 \
 	calc_mean_profile.f90 \
-	calc_radiation.f90 \
 	check_for_restart.f90 \
 	check_open.f90 \
@@ -765,8 +764,4 @@
 	mod_kinds.o \
 	modules.o
-calc_radiation.o: \
-	basic_constants_and_equations_mod.o \
-	mod_kinds.o \
-	modules.o
 check_for_restart.o: \
 	mod_kinds.o \
@@ -1451,5 +1446,4 @@
 	bulk_cloud_model_mod.o \
 	buoyancy.o \
-	calc_radiation.o \
 	chemistry_model_mod.o \
 	chem_modules.o \
Index: palm/trunk/SOURCE/calc_radiation.f90
===================================================================
--- palm/trunk/SOURCE/calc_radiation.f90	(revision 3351)
+++ 	(revision )
@@ -1,366 +1,0 @@
-!> @file calc_radiation.f90
-!------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2018 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
-!
-! Current revisions:
-! -----------------
-! 
-! 
-! Former revisions:
-! -----------------
-! $Id$
-! Modularization of all bulk cloud physics code components
-! 
-! 2718 2018-01-02 08:49:38Z maronga
-! Corrected "Former revisions" section
-! 
-! 2696 2017-12-14 17:12:51Z kanani
-! Change in file header (GPL part)
-!
-! 2233 2017-05-30 18:08:54Z suehring
-!
-! 2232 2017-05-30 17:47:52Z suehring
-! Adjustments to new topography concept
-! 
-! 2000 2016-08-20 18:09:15Z knoop
-! Forced header and separation lines into 80 columns
-! 
-! 1873 2016-04-18 14:50:06Z maronga
-! Module renamed (removed _mod)
-! 
-! 
-! 1850 2016-04-08 13:29:27Z maronga
-! Module renamed
-! 
-! 
-! 1682 2015-10-07 23:56:08Z knoop
-! Code annotations made doxygen readable 
-! 
-! 1353 2014-04-08 15:21:23Z heinze
-! REAL constants provided with KIND-attribute
-!
-! 1322 2014-03-20 16:38:49Z raasch
-! exponent 4.0 changed to integer
-!
-! 1320 2014-03-20 08:40:49Z raasch
-! ONLY-attribute added to USE-statements,
-! kind-parameters added to all INTEGER and REAL declaration statements,
-! kinds are defined in new module kinds,
-! revision history before 2012 removed,
-! comment fields (!:) to be used for variable explanations added to
-! all variable declaration statements
-!
-! 1036 2012-10-22 13:43:42Z raasch
-! code put under GPL (PALM 3.9)
-!
-! Revision 1.1  2000/04/13 14:42:45  schroeter
-! Initial revision
-!
-!
-! Description:
-! -------------
-!> Calculation of the vertical divergences of the long-wave radiation-fluxes
-!> based on the parameterization of the cloud effective emissivity
-!------------------------------------------------------------------------------!
- MODULE calc_radiation_mod
- 
-
-    USE arrays_3d,                                                             &
-        ONLY:  dzw, pt, ql, tend, d_exner, exner
-
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  c_p, lv_d_cp, sigma_sb
-
-    USE control_parameters,                                                    &
-        ONLY:  rho_surface
-
-    USE indices,                                                               &
-        ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
-
-    USE kinds
-
-    USE pegrid
-
-    PRIVATE
-    PUBLIC calc_radiation
-
-    LOGICAL, SAVE ::  first_call = .TRUE. !<
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  lwp_ground         !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  lwp_top            !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  blackbody_emission !<
-
-    INTERFACE calc_radiation
-       MODULE PROCEDURE calc_radiation
-       MODULE PROCEDURE calc_radiation_ij
-    END INTERFACE calc_radiation
- 
- CONTAINS
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!------------------------------------------------------------------------------!
-    SUBROUTINE calc_radiation
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i      !<
-       INTEGER(iwp) ::  j      !<
-       INTEGER(iwp) ::  k      !<
-       INTEGER(iwp) ::  k_help !<
- 
-       REAL(wp) :: df_p                      !<
-       REAL(wp) :: df_m                      !<
-       REAL(wp) :: effective_emission_up_m   !<
-       REAL(wp) :: effective_emission_up_p   !<
-       REAL(wp) :: effective_emission_down_m !<
-       REAL(wp) :: effective_emission_down_p !<
-       REAL(wp) :: f_up_m                    !<
-       REAL(wp) :: f_up_p                    !<
-       REAL(wp) :: f_down_m                  !<
-       REAL(wp) :: f_down_p                  !<
-       REAL(wp) :: impinging_flux_at_top     !<
-       REAL(wp) :: temperature               !<
-
-
-!
-!--    On first call, allocate temporary arrays
-       IF ( first_call )  THEN
-          ALLOCATE( blackbody_emission(nzb:nzt+1), lwp_ground(nzb:nzt+1),      &
-                    lwp_top(nzb:nzt+1) )
-          first_call = .FALSE.
-       ENDIF
-
-
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-!
-!--          Compute the liquid water path (LWP) and blackbody_emission
-!--          at all vertical levels
-             lwp_ground(nzb) = 0.0_wp
-             lwp_top(nzt+1)  = rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
-
-             temperature     = pt(nzb,j,i) * exner(nzb) + lv_d_cp * ql(nzb,j,i)
-             blackbody_emission(nzb) = sigma_sb * temperature**4
-
-             DO  k = nzb+1, nzt
-
-                k_help = ( nzt+nzb+1 ) - k
-                lwp_ground(k)   = lwp_ground(k-1) + rho_surface * ql(k,j,i) *  &
-                                  dzw(k)
-
-                lwp_top(k_help) = lwp_top(k_help+1) +                          &
-                                  rho_surface * ql(k_help,j,i) * dzw(k_help)
-
-                temperature     = pt(k,j,i) * exner(k) + lv_d_cp * ql(k,j,i)
-                blackbody_emission(k) = sigma_sb * temperature**4              &
-                                      * MERGE( 1.0_wp, 0.0_wp,                 &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-
-             ENDDO
-
-             lwp_ground(nzt+1) = lwp_ground(nzt) +                             &
-                                 rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
-             lwp_top(nzb)      = lwp_top(nzb+1)
-
-             temperature       = pt(nzt+1,j,i) * exner(nzt+1) + lv_d_cp *      &
-                                 ql(nzt+1,j,i)
-             blackbody_emission(nzt+1) = sigma_sb * temperature**4
-
-!
-!--          See Chlond '92, this is just a first guess
-             impinging_flux_at_top = blackbody_emission(nzb) - 100.0_wp
-
-             DO  k = nzb+1, nzt
-!
-!--             Save some computational time, but this may cause load
-!--             imbalances if ql is not distributed uniformly
-                IF ( ql(k,j,i) /= 0.0_wp ) THEN
-!
-!--                Compute effective emissivities
-                   effective_emission_up_p   = 1.0_wp -                        &
-                                               EXP( -130.0_wp * lwp_ground(k+1) )
-                   effective_emission_up_m   = 1.0_wp -                        &
-                                               EXP( -130.0_wp * lwp_ground(k-1) )
-                   effective_emission_down_p = 1.0_wp -                        &
-                                               EXP( -158.0_wp * lwp_top(k+1) )
-                   effective_emission_down_m = 1.0_wp -                        &
-                                               EXP( -158.0_wp * lwp_top(k-1) )  
-
-!
-!--                Compute vertical long wave radiation fluxes
-                   f_up_p = blackbody_emission(nzb) +                          &
-                            effective_emission_up_p *                          &
-                           ( blackbody_emission(k) - blackbody_emission(nzb) )
-
-                   f_up_m = blackbody_emission(nzb) +                          &
-                            effective_emission_up_m *                          &
-                           ( blackbody_emission(k-1) - blackbody_emission(nzb) )
-
-                   f_down_p = impinging_flux_at_top +                          &
-                              effective_emission_down_p *                      &
-                             ( blackbody_emission(k) - impinging_flux_at_top )
-
-                   f_down_m = impinging_flux_at_top +                          &
-                              effective_emission_down_m *                      &
-                             ( blackbody_emission(k-1) - impinging_flux_at_top )
-
-!
-!--                Divergence of vertical long wave radiation fluxes
-                   df_p = f_up_p - f_down_p
-                   df_m = f_up_m - f_down_m
-
-!
-!--                Compute tendency term         
-                   tend(k,j,i) = tend(k,j,i) -                                 &
-                                ( d_exner(k) / ( rho_surface * c_p ) *         &
-                                  ( df_p - df_m ) / dzw(k) )                   &
-                                      * MERGE( 1.0_wp, 0.0_wp,                 &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-
-                ENDIF
-
-             ENDDO
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE calc_radiation
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!------------------------------------------------------------------------------!
-    SUBROUTINE calc_radiation_ij( i, j )
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i      !<
-       INTEGER(iwp) ::  j      !<
-       INTEGER(iwp) ::  k      !<
-       INTEGER(iwp) ::  k_help !<
-
-       REAL(wp) :: df_p                      !<
-       REAL(wp) :: df_m                      !<
-       REAL(wp) :: effective_emission_up_m   !<
-       REAL(wp) :: effective_emission_up_p   !<
-       REAL(wp) :: effective_emission_down_m !<
-       REAL(wp) :: effective_emission_down_p !<
-       REAL(wp) :: f_up_m                    !<
-       REAL(wp) :: f_up_p                    !<
-       REAL(wp) :: f_down_m                  !<
-       REAL(wp) :: f_down_p                  !<
-       REAL(wp) :: impinging_flux_at_top     !<
-       REAL(wp) :: temperature               !<
-
-       
-!
-!--    On first call, allocate temporary arrays
-       IF ( first_call )  THEN
-          ALLOCATE( blackbody_emission(nzb:nzt+1), lwp_ground(nzb:nzt+1),      &
-                    lwp_top(nzb:nzt+1) )
-          first_call = .FALSE.
-       ENDIF
-
-!
-!--    Compute the liquid water path (LWP) and blackbody_emission
-!--    at all vertical levels
-       lwp_ground(nzb) = 0.0_wp
-       lwp_top(nzt+1)  = rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
-
-       temperature     = pt(nzb,j,i) * exner(nzb) + lv_d_cp * ql(nzb,j,i)
-       blackbody_emission(nzb) = sigma_sb * temperature**4
-
-       DO  k = nzb+1, nzt
-          k_help = ( nzt+nzb+1 ) - k
-          lwp_ground(k)   = lwp_ground(k-1) + rho_surface * ql(k,j,i) * dzw(k)
-
-          lwp_top(k_help) = lwp_top(k_help+1) +                                &
-                            rho_surface * ql(k_help,j,i) * dzw(k_help)
-
-          temperature     = pt(k,j,i) * exner(k) + lv_d_cp * ql(k,j,i)
-          blackbody_emission(k) = sigma_sb * temperature**4                    &
-                                      * MERGE( 1.0_wp, 0.0_wp,                 &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-
-       ENDDO
-       lwp_ground(nzt+1) = lwp_ground(nzt) +                                   &
-                           rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
-       lwp_top(nzb)      = lwp_top(nzb+1)
-
-       temperature       = pt(nzt+1,j,i) * exner(nzt+1) + lv_d_cp *            &
-                           ql(nzt+1,j,i)
-       blackbody_emission(nzt+1) = sigma_sb * temperature**4
-
-!
-!--    See Chlond '92, this is just a first guess
-       impinging_flux_at_top = blackbody_emission(nzb) - 100.0_wp
-
-       DO  k = nzb+1, nzt
-!
-!--       Store some computational time,
-!--       this may cause load imbalances if ql is not distributed uniformly
-          IF ( ql(k,j,i) /= 0.0_wp ) THEN
-!
-!--          Compute effective emissivities
-             effective_emission_up_p   = 1.0_wp -                              &
-                                         EXP( -130.0_wp * lwp_ground(k+1) )
-             effective_emission_up_m   = 1.0_wp -                              &
-                                         EXP( -130.0_wp * lwp_ground(k-1) )
-             effective_emission_down_p = 1.0_wp -                              &
-                                         EXP( -158.0_wp * lwp_top(k+1) )
-             effective_emission_down_m = 1.0_wp -                              &
-                                         EXP( -158.0_wp * lwp_top(k-1) )  
-             
-!
-!--          Compute vertical long wave radiation fluxes
-             f_up_p = blackbody_emission(nzb) + effective_emission_up_p *      &
-                     ( blackbody_emission(k) - blackbody_emission(nzb) )
-
-             f_up_m = blackbody_emission(nzb) + effective_emission_up_m *      &
-                     ( blackbody_emission(k-1) - blackbody_emission(nzb) )
-
-             f_down_p = impinging_flux_at_top + effective_emission_down_p *    &
-                       ( blackbody_emission(k) - impinging_flux_at_top )
-
-             f_down_m = impinging_flux_at_top + effective_emission_down_m *    &
-                       ( blackbody_emission(k-1) - impinging_flux_at_top )
-
-!
-!-           Divergence of vertical long wave radiation fluxes
-             df_p = f_up_p - f_down_p
-             df_m = f_up_m - f_down_m
-
-!
-!--          Compute tendency term         
-             tend(k,j,i) = tend(k,j,i) - ( d_exner(k) / ( rho_surface * c_p )  &
-                                      *  ( df_p - df_m ) / dzw(k) )            &
-                                      * MERGE( 1.0_wp, 0.0_wp,                 &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-
-          ENDIF
-
-       ENDDO
-
-    END SUBROUTINE calc_radiation_ij
-
- END MODULE calc_radiation_mod
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 3351)
+++ palm/trunk/SOURCE/header.f90	(revision 3355)
@@ -238,7 +238,4 @@
 ! 1551 2015-03-03 14:18:16Z maronga
 ! Added informal output for land surface model and radiation model. Removed typo.
-! 
-! 1496 2014-12-02 17:25:50Z maronga
-! Renamed: "radiation -> "cloud_top_radiation"
 ! 
 ! 1484 2014-10-21 10:53:05Z kanani
@@ -1940,5 +1937,4 @@
        WRITE ( io, 431 )
     ENDIF
-    IF ( cloud_top_radiation )  WRITE ( io, 132 )
     IF ( humidity  .AND.  cloud_droplets )  THEN
        WRITE ( io, 433 )
@@ -2115,6 +2111,4 @@
 131 FORMAT (' --> No pt-equation solved. Neutral stratification with pt = ', &
                   F6.2, ' K assumed')
-132 FORMAT ('     Parameterization of long-wave radiation processes via'/ &
-            '     effective emissivity scheme')
 134 FORMAT (' --> Additional prognostic equation for a passive scalar')
 135 FORMAT (' --> Solve perturbation pressure via ',A,' method (', &
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 3351)
+++ palm/trunk/SOURCE/modules.f90	(revision 3355)
@@ -415,7 +415,4 @@
 ! Increased pr_palm to 120. Increased length of dots_unit and dots_label to 13
 ! digits. Increased length of domask, do2d, and do3d to 20 digits.
-! 
-! 1496 2014-12-02 17:25:50Z maronga
-! Renamed "radiation" -> "cloud_top_radiation"
 ! 
 ! 1484 2014-10-21 10:53:05Z kanani
@@ -1300,5 +1297,4 @@
     LOGICAL ::  child_domain  = .FALSE.                          !< flag indicating that model is nested in a parent domain
     LOGICAL ::  cloud_droplets = .FALSE.                         !< namelist parameter
-    LOGICAL ::  cloud_top_radiation = .FALSE.                    !< namelist parameter
     LOGICAL ::  complex_terrain = .FALSE.                        !< namelist parameter
     LOGICAL ::  conserve_volume_flow = .FALSE.                   !< namelist parameter
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 3351)
+++ palm/trunk/SOURCE/parin.f90	(revision 3355)
@@ -298,7 +298,4 @@
 ! 1560 2015-03-06 10:48:54Z keck
 ! +recycling_yshift
-! 
-! 1496 2014-12-02 17:25:50Z maronga
-! Renamed: "radiation -> "cloud_top_radiation"
 ! 
 ! 1484 2014-10-21 10:53:05Z kanani
@@ -554,5 +551,4 @@
              canyon_width_x, canyon_width_y, canyon_wall_left,                 &
              canyon_wall_south, cfl_factor, cloud_droplets,   &
-             cloud_top_radiation,                 &
              collective_wait, complex_terrain,           &
              conserve_volume_flow,                                             &
@@ -627,5 +623,4 @@
              canyon_width_x, canyon_width_y, canyon_wall_left,                 &
              canyon_wall_south, cfl_factor, cloud_droplets,                    &
-             cloud_top_radiation,                                              &
              collective_wait, complex_terrain,                                 &
              conserve_volume_flow,                                             &
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3351)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3355)
@@ -156,7 +156,4 @@
 ! advec_s_bc_mod addded, since advec_s_bc is now a module
 !
-! 1496 2014-12-02 17:25:50Z maronga
-! Renamed "radiation" -> "cloud_top_radiation"
-!
 ! 1484 2014-10-21 10:53:05Z kanani
 ! Changes due to new module structure of the plant canopy model:
@@ -341,7 +338,4 @@
         ONLY:  buoyancy
 
-    USE calc_radiation_mod,                                                    &
-        ONLY:  calc_radiation
-
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_integrate, chem_species,  chem_prognostic_equations,       &
@@ -358,11 +352,9 @@
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry,                                                  &
-               cloud_top_radiation, constant_diffusion,                        &
+        ONLY:  air_chemistry, constant_diffusion,                              &
                dp_external, dp_level_ind_b, dp_smooth_factor, dpdxy, dt_3d,    &
                humidity, intermediate_timestep_count,                          &
                intermediate_timestep_count_max, large_scale_forcing,           &
-               large_scale_subsidence,                  &
-               neutral, nudging, &
+               large_scale_subsidence, neutral, nudging,                       &
                ocean_mode, passive_scalar, plant_canopy, pt_reference,         &
                scalar_advec, scalar_advec, simulated_time, sloping_surface,    &
@@ -827,10 +819,4 @@
                                surf_usm_v(0)%shf, surf_usm_v(1)%shf,           &
                                surf_usm_v(2)%shf, surf_usm_v(3)%shf )
-!
-!--          If required compute heating/cooling due to long wave radiation
-!--          processes
-             IF ( cloud_top_radiation )  THEN
-                CALL calc_radiation( i, j )
-             ENDIF
 
 !
@@ -1706,9 +1692,4 @@
                          surf_usm_v(0)%shf, surf_usm_v(1)%shf,                 &
                          surf_usm_v(2)%shf, surf_usm_v(3)%shf )
-!
-!--    If required compute heating/cooling due to long wave radiation processes
-       IF ( cloud_top_radiation )  THEN
-          CALL calc_radiation
-       ENDIF
 
 !
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3351)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3355)
@@ -362,6 +362,4 @@
              CASE ( 'cloud_droplets' )
                 READ ( 13 )  cloud_droplets
-             CASE ( 'cloud_top_radiation' )
-                READ ( 13 )  cloud_top_radiation
              CASE ( 'collective_wait' )
                 READ ( 13 )  collective_wait
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3351)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3355)
@@ -289,7 +289,4 @@
        WRITE ( 14 )  cloud_droplets
 
-       CALL wrd_write_string( 'cloud_top_radiation' ) 
-       WRITE ( 14 )  cloud_top_radiation
-
        CALL wrd_write_string( 'collective_wait' ) 
        WRITE ( 14 )  collective_wait