Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3370)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3371)
@@ -173,4 +173,11 @@
 
     USE arrays_3d,                                                             &
+#if defined (__nopointer)
+        ONLY:  ddzu, diss, dzu, dzw, hyp, hyrho,                               &
+               nc,                   nc_p, nr,                   nr_p,         &
+               precipitation_amount, prr, pt, d_exner, pt_init, q, ql,         &
+               qc,                   qc_p, qr,                   qr_p,         &
+               exner, zu, tnc_m, tnr_m, tqc_m, tqr_m
+#else
         ONLY:  ddzu, diss, dzu, dzw, hyp, hyrho,                               &
                nc, nc_1, nc_2, nc_3, nc_p, nr, nr_1, nr_2, nr_3, nr_p,         &
@@ -178,4 +185,5 @@
                qc, qc_1, qc_2, qc_3, qc_p, qr, qr_1, qr_2, qr_3, qr_p,         &
                exner, zu, tnc_m, tnr_m, tqc_m, tqr_m
+#endif
 
     USE averaging,                                                             &
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3370)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3371)
@@ -342,7 +342,9 @@
  MODULE urban_surface_mod
 
+    USE arrays_3d,                                                             &
 #if ! defined( __nopointer )
-    USE arrays_3d,                                                             &
-        ONLY:  dzu, hyp, zu, pt, pt_1, pt_2, p, u, v, w, hyp, tend, exner
+        ONLY:  hyp, zu, pt, p, u, v, w, tend, exner
+#else
+        ONLY:  hyp,     pt,    u, v, w, tend, exner
 #endif
 
@@ -6453,4 +6455,5 @@
                                         end_index_on_file ,                    &
                                         nxlc, nysc,                            &
+                                        nxlf, nxrf, nysf, nynf,                &
                                         nys_on_file, nyn_on_file,              &
                                         nxl_on_file, nxr_on_file )
@@ -6618,8 +6621,9 @@
                 CALL surface_restore_elements(                                 &
                                         t_green_v(1)%t, tmp_green_v(1)%t,      &
-                                        surf_usm_v(1)%start_index,             & 
+                                        surf_usm_v(1)%start_index,             &
                                         start_index_on_file,                   &
-                                        end_index_on_file ,                    &
+                                        end_index_on_file,                     &
                                         nxlc, nysc,                            &
+                                        nxlf, nxrf, nysf, nynf,                &
                                         nys_on_file, nyn_on_file,              &
                                         nxl_on_file,nxr_on_file )
@@ -6633,5 +6637,5 @@
                 CALL surface_restore_elements(                                 &
                                         t_green_v_1(1)%t, tmp_green_v(1)%t,    &
-                                        surf_usm_v(1)%start_index,             & 
+                                        surf_usm_v(1)%start_index,             &
                                         start_index_on_file,                   &
                                         end_index_on_file,                     &
@@ -6790,6 +6794,7 @@
                                         surf_usm_v(1)%start_index,             & 
                                         start_index_on_file,                   &
-                                        end_index_on_file ,                    &
+                                        end_index_on_file,                     &
                                         nxlc, nysc,                            &
+                                        nxlf, nxrf, nysf, nynf,                &
                                         nys_on_file, nyn_on_file,              &
                                         nxl_on_file, nxr_on_file )