Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3381)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3382)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Bugix: made array declaration Fortran Standard conform
+! 
+! 3378 2018-10-19 12:34:59Z kanani
 ! merge from radiation branch (r3362) into trunk
 ! (moh.hefny):
@@ -2413,18 +2416,48 @@
         INTEGER(iwp), PARAMETER                       :: nl1 = 32     !< number of directional usm variables
         CHARACTER(LEN=varnamelength), DIMENSION(nl1)  :: varlist1 = & !< list of directional usm variables
-                  (/'usm_rad_net','usm_rad_insw','usm_rad_inlw','usm_rad_inswdir',     &
-                    'usm_rad_inswdif','usm_rad_inswref','usm_rad_inlwdif','usm_wshf',  &
-                    'usm_rad_inlwref','usm_rad_outsw','usm_rad_outlw','usm_rad_hf',    &
-                    'usm_rad_ressw','usm_rad_reslw','usm_wghf','usm_wghf_window',      &
-                    'usm_wghf_green','usm_iwghf','usm_iwghf_window','usm_surfz',       &
-                    'usm_surfwintrans','usm_surfcat','usm_surfalb','usm_surfemis',     &
-                    'usm_t_surf','usm_t_surf_window','usm_t_surf_green','usm_t_green', &
-                    'usm_t_surf_10cm','usm_t_wall','usm_t_window','usm_t_green'/)
+                  (/'usm_rad_net                   ', &
+                    'usm_rad_insw                  ', &
+                    'usm_rad_inlw                  ', &
+                    'usm_rad_inswdir               ', &
+                    'usm_rad_inswdif               ', &
+                    'usm_rad_inswref               ', &
+                    'usm_rad_inlwdif               ', &
+                    'usm_wshf                      ', &
+                    'usm_rad_inlwref               ', &
+                    'usm_rad_outsw                 ', &
+                    'usm_rad_outlw                 ', &
+                    'usm_rad_hf                    ', &
+                    'usm_rad_ressw                 ', &
+                    'usm_rad_reslw                 ', &
+                    'usm_wghf                      ', &
+                    'usm_wghf_window               ', &
+                    'usm_wghf_green                ', &
+                    'usm_iwghf                     ', &
+                    'usm_iwghf_window              ', &
+                    'usm_surfz                     ', &
+                    'usm_surfwintrans              ', &
+                    'usm_surfcat                   ', &
+                    'usm_surfalb                   ', &
+                    'usm_surfemis                  ', &
+                    'usm_t_surf                    ', &
+                    'usm_t_surf_window             ', &
+                    'usm_t_surf_green              ', &
+                    'usm_t_green                   ', &
+                    'usm_t_surf_10cm               ', &
+                    'usm_t_wall                    ', &
+                    'usm_t_window                  ', &
+                    'usm_t_green                   '/)
 
         INTEGER(iwp), PARAMETER                       :: nl2 = 9      !< number of other variables
         CHARACTER(LEN=varnamelength), DIMENSION(nl2)  :: varlist2 = & !< list of other usm variables
-                  (/'usm_skyvf','usm_skyvft','usm_svf','usm_dif','usm_rad_pc_inlw',    &
-                  'usm_rad_pc_insw','usm_rad_pc_inswdir','usm_rad_pc_inswdif',         &
-                  'usm_rad_pc_inswref'/)
+                  (/'usm_skyvf                     ', &
+                    'usm_skyvft                    ', &
+                    'usm_svf                       ', &
+                    'usm_dif                       ', &
+                    'usm_rad_pc_inlw               ', &
+                    'usm_rad_pc_insw               ', &
+                    'usm_rad_pc_inswdir            ', &
+                    'usm_rad_pc_inswdif            ', &
+                    'usm_rad_pc_inswref            '/)
 
         INTEGER(iwp), PARAMETER                       :: nd = 5     !< number of directions