Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3382)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3383)
@@ -472,5 +472,5 @@
 ! Description:
 ! ------------
-!> Parin for &bulk_cloud_parameters for the microphysics module
+!> Parin for &bulk_cloud_parameters for the bulk cloud module
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_parin
@@ -501,5 +501,5 @@
        line = ' '
 !
-!--    Try to find microphysics module package
+!--    Try to find bulk cloud module namelist
        REWIND ( 11 )
        line = ' '
@@ -512,5 +512,5 @@
        READ ( 11, bulk_cloud_parameters )
 !
-!--    Set flag that indicates that the microphysics module is switched on
+!--    Set flag that indicates that the bulk cloud module is switched on
        !bulk_cloud_model = .TRUE.
 
@@ -524,5 +524,5 @@
 ! Description:
 ! ------------
-!> Check parameters routine for microphysics module
+!> Check parameters routine for bulk cloud module
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_check_parameters
@@ -608,5 +608,5 @@
 ! Description:
 ! ------------
-!> Check data output for microphysics module
+!> Check data output for bulk cloud module
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_check_data_output( var, unit )
@@ -696,5 +696,5 @@
 ! Description:
 ! ------------
-!> Check data output of profiles for microphysics module
+!> Check data output of profiles for bulk cloud module
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_check_data_output_pr( variable, var_count, unit, dopr_unit )
@@ -800,5 +800,5 @@
 ! Description:
 ! ------------
-!> Allocate microphysics module arrays and define pointers
+!> Allocate bulk cloud module arrays and define pointers
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_init_arrays
@@ -902,5 +902,5 @@
 ! Description:
 ! ------------
-!> Initialization of the microphysics module
+!> Initialization of the bulk cloud module
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_init !( dots_label, dots_unit, dots_num, dots_max )
@@ -917,5 +917,5 @@
 !        CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_label
 
-       CALL location_message( 'initializing microphysics module', .FALSE. )
+       CALL location_message( 'initializing bulk cloud module', .FALSE. )
 
        IF ( bulk_cloud_model )  THEN
@@ -1081,5 +1081,5 @@
 ! Description:
 ! ------------
-!> Header output for microphysics module
+!> Header output for bulk cloud module
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_header ( io )
@@ -1091,5 +1091,5 @@
 
 !
-!--    Write microphysics module header
+!--    Write bulk cloud module header
        WRITE ( io, 1 )
 
@@ -1122,5 +1122,5 @@
 
 
-1   FORMAT ( //' Bulk cloud microphysics module information:'/ &
+1   FORMAT ( //' Bulk cloud module information:'/ &
                ' ------------------------------------------'/ )
 2   FORMAT ( '--> Bulk scheme with liquid water potential temperature and'/ &
@@ -1678,5 +1678,5 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the microphysics module.
+!> This routine reads the respective restart data for the bulk cloud module.
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_rrd_global( found )
@@ -1742,5 +1742,5 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the microphysics module.
+!> This routine reads the respective restart data for the bulk cloud module.
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,       &
@@ -1887,5 +1887,5 @@
 ! Description:
 ! ------------
-!> This routine writes the respective restart data for the microphysics module.
+!> This routine writes the respective restart data for the bulk cloud module.
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_wrd_global
@@ -1937,5 +1937,5 @@
 ! Description:
 ! ------------
-!> This routine writes the respective restart data for the microphysics module.
+!> This routine writes the respective restart data for the bulk cloud module.
 !------------------------------------------------------------------------------!
     SUBROUTINE bcm_wrd_local